# Core

The core repository provides a wide range of commonly used components for [Api Platform](https://github.com/api-platform/api-platform) based microservices.

## Table of Contents

- [Components](#components)
- [Contributing](#contributing)
- [Credits](#credits)

## Components

List of available components:

[Api Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Api)

The api component provides a flexible framework to define and map models to microservice apis. It enables the developer to work with php objects and functions instead of raw curl requests.

[Association Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Association)



[Audit Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Audit)



[Bpm Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Bpm)



[Cache Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Cache)



[Camunda Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Camunda)



[Config Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Config)



[Container Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Container)



[Database Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Database)



[Debug Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Debug)



[Discovery Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Discovery)



[Entity Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Entity)



[Exception Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Exception)



[Form Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Form)



[Formio Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Formio)



[Func Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Func)



[Health Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Health)



[Http Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Http)



[Identity Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Identity)



[Locale Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Locale)



[Log Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Log)



[Model Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Model)



[Resolver Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Resolver)



[Security Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Security)

The security component provides a flexible framework to define acl in order to protect data and system functionality.

[Session Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Session)



[Statistic Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Statistic)



[Translation Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Translation)



[Workflow Component](https://github.com/DigitalState/Core/tree/develop/src/Ds/Component/Workflow)


## Contributing

Please read [CONTRIBUTING.md](CONTRIBUTING.md) for details on our code of conduct, and the process for submitting pull requests to us.

## Credits

This work has been developed by DigitalState.io